﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HeuristicLab.Services.Optimization.ControllerService.Interfaces {
  public class StringEntry {
    public string Key { get; set; }
    public string Text { get; set; }    
  };

  public interface IScenarioDao {
    bool Add(ScenarioEntity entity);
    bool DeleteByName(string scenarioName);
    ScenarioEntity FindByName(string scenarioName);
    IEnumerable<ScenarioEntity> GetAllEntities();
  }

  public interface IBlobDao {
    bool Add(StringEntry entry);
    bool DeleteByKey(string entryKey);
    StringEntry FindByKey(string entryKey);
  }

  public interface IDataAccessLayer {
    IScenarioDao CreateScenarioDao();
    IBlobDao CreateBlobDao();
  }
}

