﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.Net.Security;
using HeuristicLab.Services.Optimization.ControllerService.Model;

namespace HeuristicLab.Services.Optimization.ControllerService {
  [ServiceContract(ProtectionLevel = ProtectionLevel.EncryptAndSign)]
  public interface IControllerService {
    [OperationContract]
    IEnumerable<OptimizationScenario> GetOptimizationScenarios();

    [OperationContract]
    IEnumerable<string> GetOptimizationScenarioNames();

    [OperationContract]
    OptimizationScenario GetOptimizationScenarioByName(string name);

    [OperationContract]
    void ScheduleOptimizationScenario(User user, OptimizationScenario scenario);

    [OperationContract]
    IEnumerable<Job> GetJobs(User user);

    [OperationContract]
    Job GetJob(User user, string id);

    [OperationContract]
    void DeleteJob(User user, string id);

    [OperationContract]
    IList<Model.Run> GetJobResults(User user, string id);

    [OperationContract]
    bool AddHiveScenario(User user, string scenarioXml, string scenarioMapper);

    [OperationContract]
    bool DeleteHiveScenario(User user, string scenarioName);
  }
}
